/*************************************************************
 *                        Program2.c                         *
 *                   Zrozumie elektronik                   *
 *                    Licencja: CC BY 3.0                    *
 *                                                           *
 * Created: 23.08.2024 12:09:16                              *
 * Author : Andrzej Pawluczuk                                *
 *                                                           *
 *************************************************************/

#define F_CPU 16000000UL

#include <avr/io.h>

#include <util/delay.h>

#define KeybPort     PINB
#define KeyConfig1   DDRB
#define KeyConfig2   PORTB

#define KeyPin       PB0

#define DisplayPort  PORTD
#define DisplayCofig DDRD

#define NegOperator  ~
//#define NegOperator

#define SegmentAPin  PD0
#define SegmentBPin  PD1
#define SegmentCPin  PD2
#define SegmentDPin  PD3
#define SegmentEPin  PD4
#define SegmentFPin  PD5
#define SegmentGPin  PD6
#define SegmentKPin  PD7

#define SegmentA    ( 1 << SegmentAPin )
#define SegmentB    ( 1 << SegmentBPin )
#define SegmentC    ( 1 << SegmentCPin )
#define SegmentD    ( 1 << SegmentDPin )
#define SegmentE    ( 1 << SegmentEPin )
#define SegmentF    ( 1 << SegmentFPin )
#define SegmentG    ( 1 << SegmentGPin )
#define SegmentK    ( 1 << SegmentKPin )

uint8_t Counter ;

void Display ( uint8_t Ch )
{
  uint8_t PortData ;
  /*------------------------*/
  switch ( Ch )
  {
    case 0 :
      PortData = NegOperator ( SegmentA | SegmentB | SegmentC |
                 SegmentD | SegmentE | SegmentF ) ;
      break ;
    case 1 :
      PortData = NegOperator ( SegmentB | SegmentC ) ;
      break ;
    case 2 :
      PortData = NegOperator ( SegmentA | SegmentB | SegmentD |
                 SegmentE | SegmentG ) ;
      break ;
    case 3 :
      PortData = NegOperator ( SegmentA | SegmentB | SegmentC |
                 SegmentD | SegmentG ) ;
      break ;
    case 4 :
      PortData = NegOperator ( SegmentB | SegmentC | SegmentF |
                 SegmentG ) ;
      break ;
    case 5 :
      PortData = NegOperator ( SegmentA | SegmentC | SegmentD |
                 SegmentF | SegmentG ) ;
      break ;
    case 6 :
      PortData = NegOperator ( SegmentA | SegmentC | SegmentD |
                 SegmentE | SegmentF | SegmentG ) ;
      break ;
    case 7 :
      PortData = NegOperator ( SegmentA | SegmentB | SegmentC ) ;
      break ;
    case 8 :
      PortData = NegOperator ( SegmentA | SegmentB | SegmentC |
                 SegmentD | SegmentE | SegmentF | SegmentG ) ;
      break ;
    case 9 :
      PortData = NegOperator ( SegmentA | SegmentB | SegmentC |
      SegmentD | SegmentF | SegmentG ) ;
      break ;
    default :
      PortData = NegOperator ( SegmentG ) ;
  } ;
  DisplayPort = PortData ;
}


void Setup ( void )
{
  Counter = 0 ;
  KeyConfig1 &= ~ ( 1 << KeyPin ) ;
  KeyConfig2 |= 1 << KeyPin ;
  DisplayCofig = 0xFF ;
  DisplayPort = NegOperator ( 0 ) ;
  Display ( 8 ) ;
  _delay_ms ( 1000 ) ;
  Display ( 10 ) ;
  _delay_ms ( 1000 ) ;
  Display ( 0 ) ;
}


uint8_t KeyPressed ( void )
{
  uint8_t PortData ;
  /*------------------------*/
  PortData = KeybPort & ( 1 << KeyPin ) ;
  if ( PortData )
    return ( 0 ) ;
  return ( 1 ) ;
}


void Loop ( void )
{
  if ( KeyPressed ( ) )
  {
    _delay_ms ( 10 ) ;
    if ( KeyPressed ( ) )
    {
      Counter ++ ;
      if ( Counter >= 10 )
        Counter = 0 ;
      Display ( Counter ) ;
      while ( KeyPressed ( ) )
        ;
      _delay_ms ( 10 ) ;
    } ;
  } ;
}


int main ( void )
{
  Setup ( ) ;
  while ( 1 ) 
    Loop ( ) ;
}

